// Exact stochastic watersheds, C++ implementation
// Filip Malmberg 2013.				
// For description, license, and example usage see README.TXT.

#include "DisjointSet.h"

DisjointSet::DisjointSet(long n){
  data=vector<long>(n);
  for(long i=0; i<n; i++ ){
    data[i]=i;
  }
}

long DisjointSet::Union(long a, long b){
  long c = Find(a);
  long d = Find(b);

  if(c==d){return c;}

  //Replace larger index with smaller index
  if(c<d){
    data[d]=data[c];
  }
  else{
    data[c]=data[d];
  }

  return data[c]; //equivalent to "return data[d];"
}
  
long DisjointSet::Find(long a){
  if(data[a]!=a){
    data[a]=Find(data[a]);
  }

  return data[a];  
}
