// Exact stochastic watersheds, C++ implementation
// Filip Malmberg 2013.				
// For description, license, and example usage see README.TXT.

#ifndef EDGE_H
#define EDGE_H

#include <set>

class Edge{
 public:
  int p;
  int q;
  double w;
  
  Edge(int first, int second, double weight){
    p=first;
    q=second;
    w=weight;
  }

};

struct CompareEdgeByWeight{
  bool operator()(const Edge& lhs, const Edge& rhs) const{
    return lhs.w>rhs.w;
  }
};

struct CompareEdgeByWeightInv{
  bool operator()(const Edge& lhs, const Edge& rhs) const{
    return lhs.w<rhs.w;
  }
};

struct CompareEdgeByNodeIndex{
  bool operator()(const Edge& lhs, const Edge& rhs) const{
    if(lhs.p==rhs.p){
      return lhs.q<rhs.q;
    }
    else{
      return lhs.p<rhs.p;
    }
  }
};

typedef std::set<Edge,CompareEdgeByNodeIndex> EdgeSet;

#endif
