// Exact stochastic watersheds, C++ implementation
// Filip Malmberg 2013.				
// For description, license, and example usage see README.TXT.

#ifndef GRAPH_H
#define GRAPH_H

#include <vector>
#include <map>
#include <iostream>
#include <assert.h>
#include "Edge.h"

using namespace std;

//Undirected, edge weighted graph

class Graph{
 private:
  int size;
  vector<map<int, double> > node_edges;
  
 public:
  Graph(int n_nodes);

  int GetNodeCount(){ return size; }

  EdgeSet GetEdges();

  vector<Edge> GetEdgesAsVector();

  map<int, double> GetAdjacent(int p);
  
  void SetEdge(int p, int q, double w);
 
  void DeleteEdge(int p, int q);

  vector<int> GetConnectedComponents();
  
};

#endif
