// Exact stochastic watersheds, C++ implementation
// Filip Malmberg 2013.				
// For description, license, and example usage see README.TXT.

#ifndef STOCHASTIC_WS_H
#define STOCHASTIC_WS_H

#include "Graph.h"

/*---------------------------------------------------------

Returns a graph with the same vertices and edges as 'g', but with edge weights corresponding to the stochastic watershed PDF. Uses the efficient algorithm proposed by Malmberg and Luengo.

'g' is assumed to be a tree.

-----------------------------------------------------------*/

Graph StochasticWS(Graph& g, int n_seeds);


/*---------------------------------------------------------

Returns a graph with the same vertices and edges as 'g', but with edge weights corresponding to the stochastic watershed PDF. Uses the naive algorithm.

'g' is assumed to be a tree.

-----------------------------------------------------------*/

Graph StochasticWS_naive(Graph& g, int n_seeds);

#endif
